;==========================================
; ByteToDec.asm

;      

ByteToDec:

		CLRF	Hundreds		; 
		CLRF	Tens			; 
		CLRF	Ones			; 
		CLRF	Tenth			;   
		CLRF	Minus			;  ""

		#include <DS_definition.asm>
		BTFSS	FLAG_DS, .0
		RETURN

HundredsLoop:                   ;   
  		MOVLW  	.100
  		SUBWF  	DATA_INL, w
  		BTFSS  	STATUS, C		;   STATUS.C == 1   
   		GOTO  	TensLoop
  		MOVWF  	DATA_INL        ;    DATA_INL
  		INCF   	Hundreds, f     ;   
  		GOTO   	HundredsLoop

TensLoop:                       ;   
  		MOVLW  	.10
  		SUBWF  	DATA_INL, w
  		BTFSS  	STATUS, C       ;   STATUS.C == 1   
   		GOTO  	OnesLoop
  		MOVWF  	DATA_INL        ;    DATA_INL
  		INCF   	Tens, f         ;   
		GOTO	TensLoop

OnesLoop:                       ;   
  		MOVF	DATA_INL, w
  		ADDWF	Ones, f

;		MOVLW	0x00
;		MOVWF	Hundreds
;		MOVLW	0x00
;		MOVWF	Tens
;		MOVLW	0x00
;		MOVWF	Minus

;=====    ========
;=====     ============
Hundreds_switch:
		BTFSS	Hundreds, .0
		GOTO	Tens_switch
		GOTO	end_conv

Tens_switch:
		BSF		STATUS, C		;  STATUS, C  "1"
		MOVF	Tens, w
		ADDLW	-.1
		BTFSC	STATUS, C
		GOTO	Minus_Hundreds
		GOTO	Minus_Tens
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Minus_Hundreds:
		BTFSC	Minus, .3
		GOTO	Minus_H_on
		GOTO	Minus_H_off

Minus_H_off:
		MOVLW	0x0A
		MOVWF	Hundreds
		GOTO	end_conv

Minus_H_on:
		MOVF	Minus, w
		MOVWF	Hundreds
		GOTO	end_conv
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Minus_Tens:
		BTFSC	Minus, .3
		GOTO	Minus_T_on
		GOTO	Minus_T_off

Minus_T_off:
		MOVLW	0x0A
		MOVWF	Tens
		MOVWF	Hundreds
		GOTO	end_conv

Minus_T_on:
		MOVF	Minus, w
		MOVWF	Tens
		MOVLW	0x0A
		MOVWF	Hundreds
		GOTO	end_conv
;==========================================

end_conv:

		RETURN
;==========================================
