;==========================================
; DS_definition.asm

;        DS18B20  DS18S20.
;     Indication.asm


;   
;		MOVLW	0xFF ;.15
;		MOVWF	DATA_INH
;		MOVLW	0x00 ;.0
;		MOVWF	DATA_INL

;		CALL	sign_temp_DS18B20

;==========================================
		BTFSS	FLAG_DS, .0
		GOTO	Definition
		BTFSS	FLAG_DS, .1
		GOTO	DS18S20
		GOTO	DS18B20
;==========================================

;    (DS18S20  DS18B20)
Definition:
Def_DS18S20:
		BSF		STATUS, C		;  STATUS, C  "1"
		MOVF	DATA_INH, w
		ADDLW	-.1
		BTFSC	STATUS, C
		GOTO	Def_DS18B20
		BCF		STATUS, Z		;  STATUS, Z  "0"
		MOVF	DATA_INL, w
		ADDLW	-.170
		BTFSS	STATUS, Z
		GOTO	ERR_DS
		GOTO	DS18S20

Def_DS18B20:
		BCF		STATUS, Z		;  STATUS, Z  "0"
		MOVF	DATA_INH, w
		ADDLW	-.5
		BTFSS	STATUS, Z
		GOTO	ERR_DS
		BCF		STATUS, Z		;  STATUS, Z  "0"
		MOVF	DATA_INL, w
		ADDLW	-.80
		BTFSS	STATUS, Z
		GOTO	ERR_DS
		GOTO	DS18B20
;==========================================

DS18S20:
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;   
sign_temp_DS18S20:
		BTFSS	DATA_INH, .7
		GOTO	positive_temp_DS18S20
		GOTO	negative_temp_DS18S20

positive_temp_DS18S20:
		MOVLW	0x00
		MOVWF	Minus
		GOTO	format_data_DS18S20

negative_temp_DS18S20:
		MOVLW	0x0B			;   ""
		MOVWF	Minus
		COMF	DATA_INL, w		;  DATA_INL
		ADDLW	.1				;
		MOVWF	DATA_INL
		GOTO	format_data_DS18S20
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		;    
format_data_DS18S20:
		CLRF	Tenth
		RRCF	DATA_INL, f		;  - w
		;     
		BCF		DATA_INL, .7
		;    (0,0  0,5 )
		BTFSS	STATUS, C
		GOTO	Tenth_00
		GOTO	Tenth_05

Tenth_00:
		MOVLW	.0				; +0,0 
		GOTO	step2
Tenth_05:
		MOVLW	.8				; +0,5  ...8
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step2:	MULLW	0x02
		MOVF	PRODL, w
		CALL	conv_tenth		;    

		MOVWF	Tenth
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		;    
		BSF		FLAG_DS, .0
		BCF		FLAG_DS, .1
		BSF		FLAG_DS, .2
		GOTO	END_Def

;==========================================
DS18B20:
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;   
sign_temp_DS18B20:
		BTFSS	DATA_INH, .7
		GOTO	positive_temp_DS18B20
		GOTO	negative_temp_DS18B20

positive_temp_DS18B20:
		MOVLW	0x00
		MOVWF	Minus
		GOTO	format_data_DS18B20

negative_temp_DS18B20:
		MOVLW	0x0B			;   ""
		MOVWF	Minus
		COMF	DATA_INH, f		;  DATA_INH
		COMF	DATA_INL, w		;  DATA_INL

		BCF		STATUS, Z		;  STATUS, Z  "0"
		ADDLW	.1
		MOVWF	DATA_INL
		BTFSC	STATUS, Z		;  DATA_INL==0, 
		INCF	DATA_INH, f		; DATA_INH++

		GOTO	format_data_DS18B20
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   
		;      
format_data_DS18B20:
		;    DS18B20
		;BSF		STATUS, C		;  STATUS, C  "1"
		;MOVF	DATA_INL, w
		;ADDLW	-.4
		;MOVWF	DATA_INL
		;BTFSS	STATUS, C
		;DECF	DATA_INH, f
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;   
		MOVF	DATA_INL, w
		ANDLW	0x0F

		MULLW	0x02
		MOVF	PRODL, w
		;BSF		PCLATH, .0
		CALL	conv_tenth		;    
		;BCF		PCLATH, .0
		;CALL	conv_tenth		;    

		MOVWF	Tenth
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		MOVLW	0xF0
		ANDWF	DATA_INL
		MOVLW	0x0F
		ANDWF	DATA_INH, w
		ADDWF	DATA_INL, f
		SWAPF	DATA_INL, f
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		;    
		BSF		FLAG_DS, .0
		BSF		FLAG_DS, .1
		BSF		FLAG_DS, .2

		GOTO	END_Def
;==========================================

;    DS (  MAIN.asm) -
;      .
ERR_DS:
		;   !!!
		;BSF		PORT_Err, bit_Err

		BCF		INT_ON_1sec, .0
		MOVLW	0x0A ; .10
		MOVWF	Hundreds
		MOVLW	0x0C ; .12
		MOVWF	Tens
		MOVLW	0x0D ; .13
		MOVWF	Ones
		MOVLW	0x0D ; .13
		MOVWF	Tenth
		BCF		FLAG_DS, .0
		BCF		FLAG_DS, .1

;==========================================

END_Def:
;==========================================