;==========================================
; Indication.asm

;   

Indication:
		SETF	PORT_CAT
		;CLRF	PORT_CAT

		BTFSC	step_indication, .0
		GOTO	DIGIT0
		BTFSC	step_indication, .1
		GOTO	DIGIT1
		BTFSC	step_indication, .2
		GOTO	DIGIT2
		BTFSC	step_indication, .3
		GOTO	DIGIT3
;==========================================

DIGIT0:
		RLNCF	Hundreds, w
		CALL	conv_data

		;XORLW	0xFF
		MOVWF	PORT_LED
		BCF		PORT_CAT, .0
		MOVLW	b'00001101'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

DIGIT1:
		RLNCF	Tens, w
		CALL	conv_data

		;XORLW	0xFF
		MOVWF	PORT_LED
		BSF		PORT_CAT, .3
		MOVLW	b'00001011'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

DIGIT2:
		RLNCF	Ones, w
		CALL	conv_data

		BTFSC	FLAG_DS, .2
		ADDLW	.4

		;XORLW	0xFF
		MOVWF	PORT_LED
		BSF		PORT_CAT, .2
		MOVLW	b'00000111'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

DIGIT3:
		RLNCF	Tenth, w
		CALL	conv_data

		;XORLW	0xFF
		MOVWF	PORT_LED
		BSF		PORT_CAT, .1
		MOVLW	b'00001110'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

END_Indication:
		RETURN
;==========================================